#
#   Copyright (C)2017..2023 @BABOLO http://www.babolo.ru/
#   PKG = cipalib
#   All rights reserved.
#
#   Redistribution and use in source and binary forms, with or without
#   modification, are permitted provided that the following conditions
#   are met:
#   1. Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must reproduce the above copyright
#      notice, this list of conditions and the following disclaimer in the
#      documentation and/or other materials provided with the distribution.
#
#   THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
#   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
#   ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
#   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
#   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
#   OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
#   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
#   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
#   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
#
#   $Id: cipalib.make,v 1.10 2023/01/01 00:11:01 babolo Exp $

PREFIX		?= /usr/local
CIPALIB_NSET	?= pset
CIPALIB_NLEAF	?= pleaf
CIPALIB_NNODE	?= pnode
CIPALIB_LIBEDIR	= ${LIBEDIR}/cipalib
CIPALIB_PASSEM	= ${CIPALIB_LIBEDIR}/cipalib.pgoblin
CIPALIB_PLEAF	= ${CIPALIB_LIBEDIR}/pleaf.awk
CIPALIB_PNODE	= ${CIPALIB_LIBEDIR}/pnode.awk
CIPALIB_1LEAF	= ${CIPALIB_PLEAF} -v mode=1 -v pleaf=${CIPALIB_NSET}
CIPALIB_2LEAF	= ${CIPALIB_PLEAF} -v mode=2 -v pleaf=${CIPALIB_NSET}
CIPALIB_CNODE	= ${CIPALIB_PNODE} -v pleaf=${CIPALIB_NLEAF} -v pnode=${CIPALIB_NNODE}
CLEAN		+= pset pleaf pnode ${PLEAS} ${PLEAFS} ${MGEN}

.for I in ${PGOSCR}
  MGEN		+= ${I}.pgoblin
  SCRIPTS	+= ${I}.pgoblin
. ifndef(DISTROPGOSCR)
   MISC		+= ${I}.pgoblin.m4
. endif
.endfor

.for I in ${PGISCR}
  MGEN		+= ${I}.pgoblinc
  SCRIPTS	+= ${I}.pgoblinc
. ifndef(DISTROPGISCR)
   MISC		+= ${I}.pgoblinc.m4
. endif
.endfor

.for I in ${PLEA}
  PLEAS	+= ${I}.pleaf
  MGEN	+= ${I}.pleaf
. ifndef(DISTROPLEA)
   MISC		+= ${I}.pleaf.m4
. endif
.endfor

.for I in ${PLEAF}
  PLEAFS+= ${I}.pleaf
  MGEN	+= ${I}.pleaf
  DATA	+= ${I}
  CLEAN	+= ${I}
. ifndef(DISTROPLEAF)
   MISC		+= ${I}.pleaf.m4
. endif
.endfor

.if !target(${CIPALIB_NSET})
${CIPALIB_NSET}: ${PLEAS} ${PLEAFS}
	${RM} -f ${CIPALIB_NSET}
. if defined(PLEAS)
	${CIPALIB_1LEAF} ${PLEAS}
. endif
. if defined(PLEAFS)
	${CIPALIB_2LEAF} ${PLEAFS}
. endif
.endif

.if !target(${CIPALIB_NLEAF}) || !target(${CIPALIBLUDE_NNODE})
${CIPALIB_NLEAF} ${CIPALIBLUDE_NNODE}: ${PINODES}
	${RM} -f ${CIPALIB_NLEAF} ${CIPALIBLUDE_NNODE}
	${CIPALIB_CNODE} ${PINODES}
.endif

.if exists(pinodes)
. if !target(${MINICIPADB})
${MINICIPADB}: ${CIPALIB_NSET} ${CIPALIB_NLEAF} ${CIPALIB_NNODE}
	${CIPALIB_PASSEM} '${CIPADBMS} ${MINICIPADB}' ${PKG} ${DATADIR}
. endif

. if !target(preall)
preall:	def.m4 ${CIPALIB_NSET} ${CIPALIB_NLEAF} ${CIPALIB_NNODE} Makefile ${MINICIPADB}
. endif

. if !target(postinstall)
postinstall:
.  if defined(CIPADB)
	su2 -- ${CIPALIB_PASSEM} '${CIPADBMS} ${CIPAVAR}/${CIPADB}' ${PKG} ${DATADIR}
.  else
	su2 -- ${CIPALIB_PASSEM} '${CIPADBMS} ${MINICIPAVAR}/${MINICIPADB}' ${PKG} ${DATADIR}
.  endif
. endif
.endif
